#include "RobboLito.h"
#include <string.h>
#include "control.h"

static void SetOption (typePOS* POSITION, char* string)
{
  char *v;
  int Value;
  if (!memcmp (string, "Hash", 4) || !memcmp (string, "TranspositionalTabularSizing", 28))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  Value = InitHash (Value);
	  SEND ("Optional TranspositionalTabularSizing %d\n", Value);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "PawnsHash", 9) || !memcmp (string, "PawnsZobrist", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  Value = InitPawnHash (Value);
	  SEND ("Optional PawnsZobrist %d\n", Value);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "TitanicCPUsSizings", 18))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value <= 0)
	    Value = 1;
	  if (Value > 64)
	    Value = 64;
	  if (Value > MAX_CPUS)
	    Value = MAX_CPUS;
	  CPUS_SIZE = Value;
	  SEND ("Optional TitanicCPUsSizings (Capitalist!) %d\n", Value);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "TitanicMode", 11))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    TITANIC_MODE = FALSE;
	  if (!strcmp (v + 6, "true"))
	    TITANIC_MODE = TRUE;
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "BufferTime", 10))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 0)
	    Value = 0;
	  if (Value > 10000)
	    Value = 10000;
	  BUFFER_TIME = Value;
	  SEND ("Optional BufferTime %d\n", BUFFER_TIME);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "AlternativeTimeUsage", 20))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    USE_ALTERNATIVE_TIME = FALSE;
	  if (!strcmp (v + 6, "true"))
	    USE_ALTERNATIVE_TIME = TRUE;
	  SEND ("Optional AlternativeTimeUsage %s\n",
		USE_ALTERNATIVE_TIME ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "AllowInstantMoveFromHash", 24))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    ALLOW_INSTANT_MOVE = FALSE;
	  if (!strcmp (v + 6, "true"))
	    ALLOW_INSTANT_MOVE = TRUE;
	  SEND ("Optional AllowInstantMoveFromHash %s\n",
		ALLOW_INSTANT_MOVE ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "Ponder", 6))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    UCI_PONDER = FALSE;
	  if (!strcmp (v + 6, "true"))
	    UCI_PONDER = TRUE;
	  SEND ("Optional Ponder %s\n", UCI_PONDER ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "UCI_BishopPairScale", 19))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 0)
	    Value = 0;
	  if (Value > 150)
	    Value = 150;
	  UCI_BishopPairScale = Value;
	  SEND ("Optional UCI_BishopPairScale %d\n", UCI_BishopPairScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "UCI_PawnScale", 13))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 50)
	    Value = 50;
	  if (Value > 200)
	    Value = 200;
	  UCI_PawnScale = Value;
	  SEND ("Optional UCI_PawnScale %d\n", UCI_PawnScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }

  if (!memcmp (string, "UCI_KnightScale", 15))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 150)
	    Value = 150;
	  if (Value > 500)
	    Value = 500;
	  UCI_KnightScale = Value;
	  SEND ("Optional UCI_KnightScale %d\n", UCI_KnightScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "UCI_BishopScale", 15))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 150)
	    Value = 150;
	  if (Value > 500)
	    Value = 500;
	  UCI_BishopScale = Value;
	  SEND ("Optional UCI_BishopScale %d\n", UCI_BishopScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }

  if (!memcmp (string, "UCI_RookScale", 13))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 300)
	    Value = 300;
	  if (Value > 700)
	    Value = 700;
	  UCI_RookScale = Value;
	  SEND ("Optional UCI_RookScale %d\n", UCI_RookScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "UCI_QueenScale", 14))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  if (Value < 500)
	    Value = 500;
	  if (Value > 1500)
	    Value = 1500;
	  UCI_QueenScale = Value;
	  SEND ("Optional UCI_QueenScale %d\n", UCI_QueenScale);
	  InitMaterialValue ();
	  SEND ("readyok\n");
	}
    }

  if (!memcmp (string, "VerifyNullMove", 14))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    VERIFY_NULL = FALSE;
	  if (!strcmp (v + 6, "true"))
	    VERIFY_NULL = TRUE;
	  SEND ("Optional VerifyNullMove %s\n", VERIFY_NULL ? "true" : "false");
	  SEND ("readyok\n");
	}
    }

#ifdef CON_ROBBO_BUILD
  if (!memcmp (string, "RobboTripleBaseDirectory", 24))
    {
      v = strstr (string, "value");
      if (v)
	{
	  strcpy (ROBBO_TRIPLE_DIR, v + 6);
	  SEND ("Optional RobboTripleBaseDirectory %s\n", ROBBO_TRIPLE_DIR);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "LoadRobboTripleBases", 20))
    {
      LoadRobboTripleBases ();
      SEND ("readyok\n");
    }
  if (!memcmp (string, "RobboTotalBaseDirectory", 23))
    {
      v = strstr (string, "value");
      if (v)
	{
	  strcpy (ROBBO_TOTAL_DIR, v + 6);
	  SEND ("Optional RobboTotalBaseDirectory %s\n", ROBBO_TOTAL_DIR);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "RegisterRobboTotalBases", 23))
    {
      RegisterRobboTotalBases ();
      SEND ("readyok\n");
    }

  if (!memcmp (string, "RobboTotalBaseCacheSize", 23))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  SetTotalBaseCache (Value);
	  SEND ("readyok\n");
	}
    }

#endif
#ifndef MINIMAL
  if (!memcmp (string, "AlwaysAnalyze", 13))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    ALWAYS_ANALYZE = FALSE;
	  if (!strcmp (v + 6, "true"))
	    ALWAYS_ANALYZE = TRUE;
	  SEND ("Optional AlwaysAnalyze %s\n",
		ALWAYS_ANALYZE ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "SendCurrmove", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    SEND_CURR_MOVE = FALSE;
	  if (!strcmp (v + 6, "true"))
	    SEND_CURR_MOVE = TRUE;
	  SEND ("Optional SendCurrmove %s\n",
		SEND_CURR_MOVE ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
#ifdef UTILITIES
  if (!memcmp (string, "DebugTimeManagement", 19))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    DEBUG_TIME_MANAGEMENT = FALSE;
	  if (!strcmp (v + 6, "true"))
	    DEBUG_TIME_MANAGEMENT = TRUE;
	  SEND ("Optional DebugTimeManagement %s\n",
		DEBUG_TIME_MANAGEMENT ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
#endif
  if (!memcmp (string, "GetFEN", 6))
    {
      EmitFen (POSITION, STRING1);
      SEND ("info string %s\n", STRING1);
      SEND ("readyok\n");
    }
  if (!memcmp (string, "RandomCount", 11))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  RANDOM_COUNT = Value;
	  if (RANDOM_COUNT < 0)
	    RANDOM_COUNT = 0;
	  if (RANDOM_COUNT >= 8)
	    RANDOM_COUNT = 8;
	  SEND ("Optional RandomCount %d\n", RANDOM_COUNT);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "RandomBits", 10))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  RANDOM_BITS = Value;
	  if (RANDOM_BITS < 1)
	    RANDOM_BITS = 1;
	  if (RANDOM_BITS >= 3)
	    RANDOM_BITS = 3;
	  SEND ("Optional RandomBits %d\n", RANDOM_BITS);
	  SEND ("readyok\n");
	}
    }

#ifdef USER_SPLIT
  if (!memcmp (string, "SplitAtCUT", 10))
    {
      v = strstr (string, "value");
      if (v)
	{
	  if (!strcmp (v + 6, "false"))
	    SPLIT_AT_CUT = FALSE;
	  if (!strcmp (v + 6, "true"))
	    SPLIT_AT_CUT = TRUE;
	  SEND ("Optional SplitAtCUT %s\n", SPLIT_AT_CUT ? "true" : "false");
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "SplitDepthCUT", 13))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  CUT_SPLIT_DEPTH = Value;
	  if (CUT_SPLIT_DEPTH <= 16)
	    CUT_SPLIT_DEPTH = 16;
	  if (CUT_SPLIT_DEPTH >= 20)
	    CUT_SPLIT_DEPTH = 20;
	  SEND ("Optional SplitDepthCUT %d\n", CUT_SPLIT_DEPTH);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "SplitDepthALL", 13))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  ALL_SPLIT_DEPTH = Value;
	  if (ALL_SPLIT_DEPTH <= 12)
	    ALL_SPLIT_DEPTH = 12;
	  if (ALL_SPLIT_DEPTH >= 20)
	    ALL_SPLIT_DEPTH = 20;
	  SEND ("Optional SplitDepthALL %d\n", ALL_SPLIT_DEPTH);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "SplitDepthPV", 12))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  PV_SPLIT_DEPTH = Value;
	  if (PV_SPLIT_DEPTH <= 10)
	    PV_SPLIT_DEPTH = 10;
	  if (PV_SPLIT_DEPTH >= 20)
	    PV_SPLIT_DEPTH = 20;
	  SEND ("Optional SplitDepthPV %d\n", PV_SPLIT_DEPTH);
	  SEND ("readyok\n");
	}
    }
#endif
  if (!memcmp (string, "MultiPV", 7))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  MULTI_PV = Value;
	  if (MULTI_PV <= 1)
	    MULTI_PV = 1;
	  if (MULTI_PV >= 250)
	    MULTI_PV = 250;
	  SEND ("Optional MultiPV %d\n", MULTI_PV);
	  SEND ("readyok\n");
	}
    }
  if (!memcmp (string, "MultiCentiPawnPV", 16))
    {
      v = strstr (string, "value");
      if (v)
	{
	  Value = atoi (v + 6);
	  MULTI_CENTI_PAWN_PV = Value;
	  if (MULTI_CENTI_PAWN_PV <= 1)
	    MULTI_CENTI_PAWN_PV = 1;
	  if (MULTI_CENTI_PAWN_PV >= 65535)
	    MULTI_CENTI_PAWN_PV = 65535;
	  SEND ("Optional MultiCentiPawnPV %d\n", MULTI_CENTI_PAWN_PV);
	  SEND ("readyok\n");
	}
    }
#endif
}

static void uci ()
{
  SEND ("id name %s verzione %s\n", EPONYM, VERSION);
  SEND ("id author Yakov Petrovich Golyadkin, ");
  SEND ("Igor Igorovich Igoronov, Roberto Pescatore, ");
  SEND ("Yusuf Ralf Weisskopf, ");
  SEND ("Ivan Skavinsky Skavar plus Decembrists (all)\n");
  SEND ("id copyright Yakov Petrovich Golyadkin, "
	"92th plus 93th year from Revolution, PUBLICDOMAIN (workers)\n");
  SEND ("id dedication To Vladimir Ilyich\n");
  SEND ("option name Hash type spin min 1 max 65536 default 32\n");
  SEND ("option name PawnsHash type spin min 1 max 1024 default 2\n");
  SEND ("option name TitanicMode (Capitalist!) type check default false\n");
  SEND ("option name TitanicCPUsSizings (Capitalist!) type spin min 1 max %d default 1\n", MAX_CPUS);
  SEND ("option name Ponder type check default false\n");
  SEND ("option name VerifyNullMove type check default true\n");
  SEND ("option name AlternativeTimeUsage (beta) type check default false\n");
  SEND ("option name AllowInstantMoveFromHash (ponder off only) type check default true\n");
  SEND ("option name BufferTime (milliseconds) type spin min 0 max 10000 default 0\n");
#ifdef CON_ROBBO_BUILD
  SEND ("option name RobboTripleBaseDirectory type string default NULL\n");
  SEND ("option name LoadRobboTripleBases type button\n");
  SEND ("option name RobboTotalBaseDirectory type string default NULL\n");
  SEND ("option name RegisterRobboTotalBases type button\n");
  SEND ("option name RobboTotalBaseCacheSize type spin min 1 max 1024 default 1\n");
#endif
#ifdef UTILITIES
  SEND ("option name DebugTimeManagement type check default false\n");
#endif
#ifndef MINIMAL
  SEND ("option name MultiPV type spin min 1 max 250 default 1\n");
  SEND ("option name MultiCentiPawnPV type spin min 1 max 65535 default 65535\n");
  SEND ("option name RandomCount type spin min 0 max 8 default 0\n");
  SEND ("option name RandomBits type spin min 1 max 3 default 1\n");
#ifdef USER_SPLIT
  SEND ("option name SplitAtCUT (half ply) type check default true\n");
  SEND ("option name SplitDepthCUT (half ply) type spin min 16 max 20 default 16\n");
  SEND ("option name SplitDepthALL (half ply) type spin min 12 max 20 default 14\n");
  SEND ("option name SplitDepthPV (half ply) type spin min 10 max 20 default 14\n");
#endif
  SEND ("option name UCI_BishopPairScale (centipawns) type spin min 0 max 150 default 45\n");
  SEND ("option name UCI_PawnScale (centipawns) type spin min 50 max 200 default 100\n");
  SEND ("option name UCI_KnightScale (centipawns) type spin min 150 max 500 default 300\n");
  SEND ("option name UCI_BishopScale (centipawns) type spin min 150 max 500 default 310\n");
  SEND ("option name UCI_RookScale (centipawns) type spin min 300 max 700 default 500\n");
  SEND ("option name UCI_QueenScale (centipawns) type spin min 500 max 1500 default 950\n");
  SEND ("option name AlwaysAnalyze type check default false\n");
  SEND ("option name SendCurrmove type check default false\n");
  SEND ("option name GetFEN type button\n");
#endif
  SEND ("uciok\n");
}

static void readyok ()
{
  SEND ("readyok\n");
}

static void quit ()
{
  exit (0);
}

static void ParseInput (typePOS* POSITION, char* I)
{
  if (!strcmp (I, "quit"))
    quit ();
  if (!strcmp (I, "stop"))
    HaltSearch (0);
  if (!strcmp (I, "isready"))
    readyok ();
  if (!strcmp (I, "ponderhit"))
    ponderhit ();
  if (!strcmp (I, "ucinewgame"))
    {
      HaltSearch (0);
      NewGame (POSITION, TRUE);
    }
  if (JUMP_IS_SET)
    return;
#if defined (BENCHMARK) || defined(UTILITIES)
  if (!strcmp (I, "benchmark"))
    BenchMark (POSITION, "go movetime 1000");
  else if (!memcmp (I, "benchmark", 9)) /* run benchmark */
    BenchMark (POSITION, I + 10);
#endif
#if defined (UTILITIES)
  if (!memcmp (I, "perft-check", 11))
    Perfd (POSITION, atoi (I + 12), atoi (I + 14)); /* HACK */
  if (!memcmp (I, "drawboard", 9))
    DrawBoard (POSITION);
  if (!strcmp (I, "eval"))
    EvalExplanation (POSITION, -32767, 32767, 0);
  if (!memcmp (I, "perft ", 6))
    PERFD (POSITION, atoi (I + 6));
  if (!memcmp (I, "verify-triple", 13))
    {
      int p[4];
      char A[64], B[64], C[64], D[64];
      sscanf (I + 14, "%s %s %s %s", A, B, C, D);
      p[0] = atoi(A);
      p[1] = atoi(B);
      p[2] = atoi(C);
      p[3] = atoi(D);
      VerifyTripleBase (POSITION, p);
    }
#endif
  if (!memcmp (I, "go", 2))
    {
      InitSearch (POSITION, I);
      if (BOARD_IS_OK)
	Search (POSITION);
    }
  if (!memcmp (I, "position", 8))
    InitPosition (POSITION, I + 9);
  if (!memcmp (I, "setoption name", 14))
    SetOption (POSITION, I + 15);
  if (!strcmp (I, "uci"))
    uci ();
}

void Input (typePOS* POSITION)
{
  char I[65536];
  fgets (I, 65536, stdin);
  I[strlen (I) - 1] = 0;
  ParseInput (POSITION, I);
}
